<?php   
 chdir('../');
 /*
     Example1 : A simple line chart
 */
 

include_once("./config.php");
include_once("./lib/loader.php");
include_once(DIR_MODULES."application.class.php");
include("./pChart/pData.class");   
include("./pChart/pChart.class");  


$db=new mysql(DB_HOST, '', DB_USER, DB_PASSWORD, DB_NAME); // connecting to database
$settings=SQLSelect("SELECT NAME, VALUE FROM settings");


$total=count($settings);
for($i=0;$i<$total;$i++) {
  Define('SETTINGS_'.$settings[$i]['NAME'], $settings[$i]['VALUE']);
}


if (!$width) {
  $w=610;
  } else {
      $w=(int)$width;
}


$DataSet = new pData;

if ($p!='') {
  if (preg_match('/(.+)\.(.+)/is', $p, $m)) {
    $obj=getObject($m[1]);
    $prop_id=$obj->getPropertyByName($m[2], $obj->class_id, $obj->id);
  }
}


$pvalue=SQLSelectOne("SELECT * FROM pvalues WHERE PROPERTY_ID='".$prop_id."' AND OBJECT_ID='".$obj->id."'");

if (!$pvalue['ID']) {
  exit;
}

if ($_GET['op']=='value') {
  echo $pvalue['VALUE'];
  exit;
}


$end_time=time();


if ($_GET['px']) {
  $px_per_point=(int)$_GET['px'];
  } else {
      $px_per_point=6;
}


if (preg_match('/(\d+)d/', $type, $m)) {
  $total=(int)$m[1];
  $period=round(($total*24*60*60)/(($w-80)/$px_per_point)); // seconds
  $start_time=$end_time-$total*24*60*60;

  } elseif (preg_match('/(\d+)h/', $type, $m)) {
     $total=(int)$m[1];
     $period=round(($total*60*60)/(($w-80)/$px_per_point)); // seconds
     $start_time=$end_time-$total*60*60;

  } elseif (preg_match('/(\d+)m/', $type, $m)) {
     $total=(int)$m[1];
     $period=round(($total*31*24*60*60)/(($w-80)/$px_per_point)); // seconds
     $start_time=$end_time-$total*31*24*60*60;

  } elseif (preg_match('/(\d+)\/(\d+)\/(\d+)/', $_GET['start'], $m) && $_GET['interval']) {
     $period=(int)$_GET['interval']; //seconds
     $start_time=mktime(0, 0, 0, $m[2], $m[3], $m[1]);
     $total=1;
}


if ($total>0) {
  $px=0;
  $px_passed=0;

  $dt=date('Y-m-d', $start_time);

  while($start_time<$end_time) {
     $ph=SQLSelectOne("SELECT ID, VALUE FROM phistory WHERE VALUE_ID='".$pvalue['ID']."' AND ADDED<=('".date('Y-m-d H:i:s', $start_time)."') ORDER BY ADDED DESC LIMIT 1");
     if ($ph['ID']) {
       $values[]=(float)$ph['VALUE'];
     } else {
        $values[]=0;
     }

     if ($px_passed>30) {
       if (date('Y-m-d', $start_time)!=$dt) {
         $hours[]=date('d/m', $start_time);
         $dt=date('Y-m-d', $start_time);
       } else {
           $hours[]=date('H:i', $start_time);
       }
       $px_passed=0;
     } else {
        $hours[]='';
     }

     $start_time+=$period;
     $px+=$px_per_point;
     $px_passed+=$px_per_point;

  } // end of while

  $DataSet->AddPoint($values,"Serie1");  
  $DataSet->AddPoint($hours,"Serie3");  

  } else {

   $DataSet->AddPoint(0,"Serie1");
   $DataSet->AddPoint(0,"Serie3");
  
} // end of if ($total>0)


if ($_GET['op']=='values') {
  echo json_encode($values);
  exit;
}

if ($_GET['op']=='json') {
  //header("Content-type: text/json");
  $ret = array();
  $ret['VALUES']=$values;
  $ret['TIME']=$hours;
  echo json_encode($ret);
  exit;
}


$DataSet->AddAllSeries();  
$DataSet->RemoveSerie("Serie3");  
$DataSet->SetAbsciseLabelSerie("Serie3");  

$DataSet->SetSerieName("24 hours","Serie1");  
//$DataSet->SetYAxisName($p);  

  
if ($unit) {
  $DataSet->SetYAxisUnit($unit);
} else {
    $DataSet->SetYAxisUnit("C");  
}


$DataSet->SetXAxisUnit("");  
   

if (!$height) {
 $h=210;
} else {
    $h=(int)$height;
  }
  

if ($_GET['objt']=='generic') {
  $objtype = "generic";
  } elseif ($_GET['objt']=='therm1') {
    $objtype = "therm1";
  } elseif ($_GET['objt']=='therm2') {
    $objtype = "therm2";
  } elseif ($_GET['objt']=='sensors1') {
    $objtype = "sensors1";
  } elseif ($_GET['objt']=='sensors2') {
    $objtype = "sensors2";
  } else {
    
}
  
if ($_GET['caR']) {
  $caR=$_GET['caR'];
} else {
    $caR=230;
  }
	
if ($_GET['caG']) {
  $caG=$_GET['caG'];
} else {
    $caG=100;
  }
	
if ($_GET['caB']) {
    $caB=$_GET['caB'];
} else {
    $caB=100;
  }
	
if ($_GET['cpR']) {
    $cpR=$_GET['cpR'];
} else {
    $cpR=100;
  }
	
if ($_GET['cpG']) {
    $cpG=$_GET['cpG'];
} else {
    $cpG=100;
  }
	
if ($_GET['cpB']) {
    $cpB=$_GET['cpB'];
} else {
    $cpB=100;
  }
	
	

if ($objtype == "therm1") {
    
     $wi=130;
     $hi=296;
     $t1bg=255;
		 
	 $Test = new pChart($wi,$hi);
     $Test->setColorPalette(0,100,140,220);

     //!!! Background graphics (R,G,G,1/Y)
     // $Test->drawGraphAreaGradient(132,153,172,50,TARGET_BACKGROUND);  

     $Test->setFontProperties("./pChart/Fonts/tahoma.ttf",8);  
     $Test->setGraphArea(0,0,$wi,$hi);  
	
	 // Background
     $Test->drawBackground($t1bg,$t1bg,$t1bg);
	
	 // SQL q
	 $qTempStreet=SQLSelectOne("SELECT * FROM pvalues WHERE pvalues.ID='65'");
     $TempStreetValue=$qTempStreet[VALUE];
	
     // Body
	 $Test->drawFilledRoundedRectangle(23,0,72,250,10,200,200,200); // gray/body
     $Test->drawFilledCircle(48,250,45,200,200,200,0); // circle gray/body
     $Test->drawFilledRectangle(38,30,58,230,240,240,240,FALSE,100); // white
	
	 // Marks
     $Test->drawLine(32,40,64,40,150,150,150,FALSE);
     $Test->drawLine(32,80,64,80,150,150,150,FALSE);
     $Test->drawLine(32,120,64,120,150,150,150,FALSE);
     $Test->drawLine(32,160,64,160,150,150,150,FALSE);
     $Test->drawLine(32,200,64,200,150,150,150,FALSE);
  
     // Limits
     $Test->setFontProperties("./pChart/Fonts/tahoma.ttf",14);
     $Test->drawTextBox(90,20,140,60,"30"."",0,255,100,100,ALIGN_LEFT,FALSE,-1,-1,-1,100);
     $Test->drawTextBox(90,110,140,130,"0"."",0,100,100,100,ALIGN_LEFT,FALSE,-1,-1,-1,100);
     $Test->drawTextBox(80,190,140,210,"-30"."",0,100,100,255,ALIGN_LEFT,FALSE,-1,-1,-1,100);
  
     // Color temp  
     if ($TempStreetValue > 0) {
       $tcR=$caR; $tcG=$caG; $tcB=$caB;
      } else {
          $tcR=130; $tcG=160; $tcB=230;
        } 
	
     $Test->drawFilledCircle(48,250,30,$tcR,$tcG,$tcB,0); // red/blue
     $Test->drawFilledRectangle(38,120-$TempStreetValue*2.7,58,230,$tcR,$tcG,$tcB,FALSE,100); // red/blue
    
	 // Current temp
     $Test->setFontProperties("./pChart/Fonts/tahoma.ttf",16);
     $Test->drawTextBox(32,240,50,260,"$TempStreetValue"."",0,255,255,255,ALIGN_LEFT,FALSE,-1,-1,-1,100);
     $Test->setFontProperties("./pChart/Fonts/tahoma.ttf",8);
	 
		 

	} elseif ($objtype == "therm2") {
	     
    } elseif ($objtype == "sensors1") {
	
	} elseif ($objtype == "generic") {
 
	} elseif ($objtype == "sensors3") {
	
	} elseif ($objtype == "sensors4") {
	
	} elseif ($objtype == "sensors5") {
	
	} else {
    
    } // end of ($objtype == " ")
  
 
 Header("Content-type:image/png");
 imagepng($Test->Picture);

 $db->Disconnect(); // closing database connection